-- MejLayout.lua
local NameOfLayout = "noBrainShift"
local Description
local layerFrame

local debugging = false

local function Layout(mainFrame, cds)

	-- Update()
	-- CreateCastFrame( spellTexture, RTframe, height, width, relwhich, relto )
	-- createLayout()
	-- deleteLayout()

	RunScript(MoonTime_DB["Layout_noBrain"]["boxtext"])
	
	
	
	local time_newicon = GetTime();
	local oldcast = mynext(cds);
	local newcast;
	local dim;
	
	local SR_CD
	local isLunar
	local isSolar
	local eclipseDirection
	local eclipsePower
	local MF_CD
	local SunF_CD
	local IS_CD
	local FF_CD

	local MoonTimeNextCastframe
	local MoonTimeEclipseframe
	local MoonTimeMFframe
	local MoonTimeSunFframe
	local MoonTimeStarrainframe
	local MoonTimeFaerieFireframe

	local layerFrame = CreateFrame("Frame", "layerFrame", mainFrame )
	layerFrame:SetHeight( mainFrame:GetHeight() )
	layerFrame:SetWidth( mainFrame:GetWidth() )
	layerFrame:SetPoint("CENTER")
	layerFrame:Hide()
	

local TierListe = {}




layerFrame.Update = function()
	SR_CD = cds:GetStarfallCD()
	Treants_CD = cds:GetTreantsCD()
	isLunar = cds:isLunar()
	isSolar = cds:isSolar()
	eclipseDirection, eclipsePower = cds:GetEclipseDirection()
	MF_CD = cds:GetMoonfireCD()
	SunF_CD = cds:GetSunfireCD()
	IS_CD = cds:GetInsectSwarmCD()
	FF_CD = cds:GetFaerieFireCD()
	CA_CD = cds:GetCelestialAlignmentCD()


	-- MoonTimeNextCastframe
if ( MoonTime_DB["Layout_noBrainShift"]["MoonTimeNextCastframe"]["active"] ) then 
	MoonTimeNextCastframe:Show()
	newcast = mynext(cds)
	
	if oldcast ~= newcast then
		time_newicon = GetTime();
	end
	oldcast = newcast

	dim = MoonTime_DB["Layout_noBrainShift"]["MoonTimeNextCastframe"]["xdim"];
	MoonTimeNextCastframe:SetIcon(newcast)
	if MoonTime_DB["Layout_noBrain"]["blinkspells"][newcast] then
	--GetTime-time_newicon -- wenn 0 volle gre
						--	wenn time_descale normale gre
		dim = max(MoonTime_DB["Layout_noBrainShift"]["MoonTimeNextCastframe"]["xdim"]*MoonTime_DB["Layout_noBrain"]["blink_factor"]*(1-((GetTime()-time_newicon)/MoonTime_DB["Layout_noBrain"]["blink_time_descale"])^5),MoonTime_DB["Layout_noBrainShift"]["MoonTimeNextCastframe"]["xdim"]);
		alpha = min( 0.75+((GetTime()-time_newicon)/MoonTime_DB["Layout_noBrain"]["blink_time_descale"])^5/2 , 1 )
	end
	
	MoonTimeNextCastframe:SetBackdropColor(1,1,1,alpha)
	MoonTimeNextCastframe:SetHeight(dim)
	MoonTimeNextCastframe:SetWidth(dim)
	alpha = 1;
else
	MoonTimeNextCastframe:Hide()
end

-- MoonTimeEclipseframe
if ( MoonTime_DB["Layout_noBrainShift"]["MoonTimeEclipseframe"]["active"] ) then
	if ( eclipseDirection == "moon" ) then
		MoonTimeEclipseframe:SetIcon(Solar_icon)
	else
		MoonTimeEclipseframe:SetIcon(Lunar_icon)
	end
	MoonTimeEclipseframe:Show()
	
	if ( MoonTime_DB["Layout_noBrainShift"]["MoonTimeEclipseframe"]["appearance"] == "text" ) then
		if ( eclipsePower >= 0 ) then
			MoonTimeEclipseframe:SetText( "|cffffff00".. eclipsePower .."|r" )
		else
			MoonTimeEclipseframe:SetText( "|cff0088ff".. -eclipsePower .."|r" )
		end 
		if ( abs(eclipsePower) == 100 ) then
			MoonTimeEclipseframe:SetTextHeight(8)
		else
			MoonTimeEclipseframe:SetTextHeight(12)
		end
	end
	MoonTimeEclipseframe:SetFrameLevel(100)
else
	MoonTimeEclipseframe:Hide()
end

-- MoonTimeMFframe
if ( MoonTime_DB["Layout_noBrainShift"]["MoonTimeMFframe"]["active"] ) then
	MoonTimeMFframe:SetText( '' )
	MoonTimeMFframe:Show()
	
	if ( MF_CD > 0 ) then
		if MoonTime_DB["Layout_noBrainShift"]["MoonTimeMFframe"]["appearance"] == "text" then
			MoonTimeMFframe:SetText( '|cfff6ffff' .. math.ceil(MF_CD) .. '|r' )
		elseif MoonTime_DB["Layout_noBrainShift"]["MoonTimeMFframe"]["appearance"] == "popup" then
			MoonTimeMFframe:Hide()
		else
			MoonTimeMFframe:SetText( ' ' )
		end
	end
else
	MoonTimeMFframe:Hide()
end	

-- MoonTimeSunFframe
if ( MoonTime_DB["Layout_noBrainShift"]["MoonTimeSunFframe"]["active"] ) then
	MoonTimeSunFframe:SetText( '' )
	MoonTimeSunFframe:Show()
	
	if ( SunF_CD > 0 ) then
		if MoonTime_DB["Layout_noBrainShift"]["MoonTimeSunFframe"]["appearance"] == "text" then
			MoonTimeSunFframe:SetText( '|cfff6ffff' .. math.ceil(SunF_CD) .. '|r' )
		elseif MoonTime_DB["Layout_noBrainShift"]["MoonTimeSunFframe"]["appearance"] == "popup" then
			MoonTimeSunFframe:Hide()
		else
			MoonTimeSunFframe:SetText( ' ' )
		end
	end
else
	MoonTimeSunFframe:Hide()
end	

-- MoonTimeStarrainframe
if ( MoonTime_DB["Layout_noBrainShift"]["MoonTimeStarrainframe"]["active"] ) then

	MoonTimeStarrainframe:SetText( '' )
	MoonTimeStarrainframe:Show()
	
	if ( SR_CD > 1.5 ) then
		if MoonTime_DB["Layout_noBrainShift"]["MoonTimeStarrainframe"]["appearance"] == "text" then
			MoonTimeStarrainframe:SetText( '|cfff6ffff' .. math.ceil(SR_CD) .. '|r' )
		elseif MoonTime_DB["Layout_noBrainShift"]["MoonTimeStarrainframe"]["appearance"] == "popup" then
			MoonTimeStarrainframe:Hide()
		else
			MoonTimeStarrainframe:SetText( ' ' )
		end
	end
else
	MoonTimeStarrainframe:Hide()
end
		
-- MoonTimeFaerieFireframe
if ( MoonTime_DB["Layout_noBrainShift"]["MoonTimeFaerieFireframe"]["active"] ) then

	MoonTimeFaerieFireframe:SetText( '' )
	MoonTimeFaerieFireframe:Show()
	
	if ( FF_CD > 1.5 ) then
		if MoonTime_DB["Layout_noBrainShift"]["MoonTimeFaerieFireframe"]["appearance"] == "text" then
			if FF_CD > 99 then
				MoonTimeFaerieFireframe:SetText( '|cfff6ffff' .. math.ceil(FF_CD/60) .. 'm|r' )
			else
				MoonTimeFaerieFireframe:SetText( '|cfff6ffff' .. math.ceil(FF_CD) .. '|r' )
			end
		elseif MoonTime_DB["Layout_noBrainShift"]["MoonTimeFaerieFireframe"]["appearance"] == "popup" then
			MoonTimeFaerieFireframe:Hide()
		else
			MoonTimeFaerieFireframe:SetText( ' ' )
		end
	end
else
	MoonTimeFaerieFireframe:Hide()
end

-- MoonTimeCelestialAlignmentframe
if ( MoonTime_DB["Layout_noBrainShift"]["MoonTimeCelestialAlignmentframe"]["active"] ) then

	MoonTimeCelestialAlignmentframe:SetText( '' )
	MoonTimeCelestialAlignmentframe:Show()
	
	if ( CA_CD > 1.5 ) then
		if MoonTime_DB["Layout_noBrainShift"]["MoonTimeCelestialAlignmentframe"]["appearance"] == "text" then
			if CA_CD > 99 then
				MoonTimeCelestialAlignmentframe:SetText( '|cfff6ffff' .. math.ceil(CA_CD/60) .. 'm|r' )
			else
				MoonTimeCelestialAlignmentframe:SetText( '|cfff6ffff' .. math.ceil(CA_CD) .. '|r' )
			end
		elseif MoonTime_DB["Layout_noBrainShift"]["MoonTimeCelestialAlignmentframe"]["appearance"] == "popup" then
			MoonTimeCelestialAlignmentframe:Hide()
		else
			MoonTimeCelestialAlignmentframe:SetText( ' ' )
		end
	end
else
	MoonTimeCelestialAlignmentframe:Hide()
end
	

-- TierFrames	
	
for a = 1, 18, 1 do

	local name, texture, tier, column, selected, available = GetTalentInfo(a)	
	--print(name)

	if ( selected and MoonTime_DB["Layout_noBrainShift"][name]["active"] ) then
		local CD = cds:GetTalentCD(a)

		TierListe[name]:SetText( '' )
		TierListe[name]:Show()
	
		if ( CD > 1.5 ) then
			if MoonTime_DB["Layout_noBrainShift"][name]["appearance"] == "text" then
				if CD > 99 then
					TierListe[name]:SetText( '|cfff6ffff' .. math.ceil(CD/60) .. 'm|r' )
				else
					TierListe[name]:SetText( '|cfff6ffff' .. math.ceil(CD) .. '|r' )
				end
			elseif MoonTime_DB["Layout_noBrainShift"][name]["appearance"] == "popup" then
				TierListe[name]:Hide()
			else
				TierListe[name]:SetText( ' ' )
			end
		end
	else
		TierListe[name]:Hide()
	end
end



end	
	
	
	
	
	
	
	
	
	layerFrame.CreateCastFrame = function( spellTexture, RTframe, width, height, relwhich, relto, xoff, yoff )
		if not xoff then xoff= 0 end
		if not yoff then yoff= 0 end

		local frame = CreateFrame( "Frame", "MTCastframe"..RTframe:GetName(), layerFrame )
		frame:SetBackdrop({
			bgFile = spellTexture,
			tile = false, tileSize = height, edgeSize = 0,
			insets = { left = 0, right = 0, top = 0, bottom = 0 }
		})
		frame:SetHeight(height)
		frame:SetWidth(width)
		frame:SetPoint(relwhich, RTframe, relto, xoff, yoff)

		local labelframe = frame:CreateFontString(nil,"ARTWORK","GameFontNormal")
		labelframe:SetPoint("TOPLEFT", frame, "TOPLEFT")
		labelframe:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT")
		labelframe:SetTextColor( 1, 1, 1, 1 );
		frame.SetText = function( self, msg )
			if( msg == '' ) then
				frame:SetBackdropColor(1,1,1,1)		
			else
				frame:SetBackdropColor(1,1,1,.5)	
			end
			labelframe:SetText(msg)
		end
		frame.SetTextHeight = function( self, height )
			labelframe:SetTextHeight(height)
		end
		frame.SetIcon = function( self, icon )
			frame:SetBackdrop({bgFile = icon})
		end
		
		return frame
	end

	layerFrame.createLayout = function ()
		MoonTimeMFframe = layerFrame.CreateCastFrame( MF_icon, layerFrame, MoonTime_DB["Layout_noBrainShift"]["MoonTimeMFframe"]["xdim"], MoonTime_DB["Layout_noBrainShift"]["MoonTimeMFframe"]["ydim"], "CENTER", "CENTER",MoonTime_DB["Layout_noBrainShift"]["MoonTimeMFframe"]["xoffset"],MoonTime_DB["Layout_noBrainShift"]["MoonTimeMFframe"]["yoffset"])
		MoonTimeSunFframe = layerFrame.CreateCastFrame( SunF_icon, layerFrame, MoonTime_DB["Layout_noBrainShift"]["MoonTimeSunFframe"]["xdim"], MoonTime_DB["Layout_noBrainShift"]["MoonTimeSunFframe"]["ydim"], "CENTER", "CENTER",MoonTime_DB["Layout_noBrainShift"]["MoonTimeSunFframe"]["xoffset"],MoonTime_DB["Layout_noBrainShift"]["MoonTimeSunFframe"]["yoffset"])
		MoonTimeStarrainframe = layerFrame.CreateCastFrame( SR_icon, layerFrame, MoonTime_DB["Layout_noBrainShift"]["MoonTimeStarrainframe"]["xdim"], MoonTime_DB["Layout_noBrainShift"]["MoonTimeStarrainframe"]["ydim"], "CENTER", "CENTER",MoonTime_DB["Layout_noBrainShift"]["MoonTimeStarrainframe"]["xoffset"],MoonTime_DB["Layout_noBrainShift"]["MoonTimeStarrainframe"]["yoffset"])
		MoonTimeFaerieFireframe = layerFrame.CreateCastFrame( FF_icon, layerFrame, MoonTime_DB["Layout_noBrainShift"]["MoonTimeFaerieFireframe"]["xdim"], MoonTime_DB["Layout_noBrainShift"]["MoonTimeFaerieFireframe"]["ydim"], "CENTER", "CENTER",MoonTime_DB["Layout_noBrainShift"]["MoonTimeFaerieFireframe"]["xoffset"],MoonTime_DB["Layout_noBrainShift"]["MoonTimeFaerieFireframe"]["yoffset"])
		MoonTimeEclipseframe = layerFrame.CreateCastFrame( "", layerFrame, MoonTime_DB["Layout_noBrainShift"]["MoonTimeEclipseframe"]["xdim"], MoonTime_DB["Layout_noBrainShift"]["MoonTimeEclipseframe"]["ydim"], "CENTER", "CENTER",MoonTime_DB["Layout_noBrainShift"]["MoonTimeEclipseframe"]["xoffset"],MoonTime_DB["Layout_noBrainShift"]["MoonTimeEclipseframe"]["yoffset"])
		MoonTimeNextCastframe = layerFrame.CreateCastFrame( "", layerFrame, MoonTime_DB["Layout_noBrainShift"]["MoonTimeNextCastframe"]["xdim"], MoonTime_DB["Layout_noBrainShift"]["MoonTimeNextCastframe"]["ydim"], "CENTER", "CENTER",MoonTime_DB["Layout_noBrainShift"]["MoonTimeNextCastframe"]["xoffset"],MoonTime_DB["Layout_noBrainShift"]["MoonTimeNextCastframe"]["yoffset"])
		MoonTimeCelestialAlignmentframe = layerFrame.CreateCastFrame( CA_icon, layerFrame, MoonTime_DB["Layout_noBrainShift"]["MoonTimeCelestialAlignmentframe"]["xdim"], MoonTime_DB["Layout_noBrainShift"]["MoonTimeCelestialAlignmentframe"]["ydim"], "CENTER", "CENTER",MoonTime_DB["Layout_noBrainShift"]["MoonTimeCelestialAlignmentframe"]["xoffset"],MoonTime_DB["Layout_noBrainShift"]["MoonTimeCelestialAlignmentframe"]["yoffset"])
		
		for a = 1, 18, 1 do
			local name, texture = GetTalentInfo(a, 1, nil, nil, 11)	
--print(name)			
			TierListe[name] = layerFrame.CreateCastFrame( texture, layerFrame, MoonTime_DB["Layout_noBrainShift"][name]["xdim"], MoonTime_DB["Layout_noBrainShift"][name]["ydim"], "CENTER", "CENTER",MoonTime_DB["Layout_noBrainShift"][name]["xoffset"],MoonTime_DB["Layout_noBrainShift"][name]["yoffset"])
		end
end	

	layerFrame.deleteLayout = function()
		MoonTimeNextCastframe:Hide()
		MoonTimeNextCastframe = nil
		MoonTimeEclipseframe:Hide()
		MoonTimeEclipseframe = nil
		MoonTimeMFframe:Hide()
		MoonTimeMFframe = nil
		MoonTimeSunFframe:Hide()
		MoonTimeSunFframe = nil
		MoonTimeStarrainframe:Hide()
		MoonTimeStarrainframe = nil
		MoonTimeFaerieFireframe:Hide()
		MoonTimeFaerieFireframe = nil
		MoonTimeCelestialAlignmentframe:Hide()
		MoonTimeCelestialAlignmentframe = nil
for a = 1, 18, 1 do

	local name, texture = GetTalentInfo(a, 1, nil, nil, 11)		
	TierListe[name]:Hide()
	TierListe[name] = nil
	
end
		
		layerFrame:Hide()
		layerFrame = nil
	end
	


	return layerFrame
end

-- ****************************************
--
-- DO NOT CHANGE ANYTHING BELOW THIS 
--
-- ****************************************

local function registerLayout( name )									-- Beginn initialize
	local LayoutFrame
	local frame = CreateFrame( "Frame", name, UIPARENT	)
	frame.ID = name
	frame:RegisterEvent("VARIABLES_LOADED");
	
	
	

	--frame:SetScript("OnUpdate", function(self, event, ... ) OnUpdate(event, ...) end)
	
	
	frame:SetScript("OnEvent", 
		function( self, event )
		
			if event=="VARIABLES_LOADED" then							-- falls das ausloesende Event VARIABLES_LOADED ist ...
																		-- werden die ausstehenden Events registriert
				if ( GetLocale() == "deDE" ) then
					frame.description = MoonTime_noBrainShift_Strings["deDE"]["description"]
				else
					frame.description = MoonTime_noBrainShift_Strings["enGB"]["description"]
				end
				
				frame:SetScript("OnUpdate", function(self, event, ... ) 		
					name = GetTalentInfo(18, 1, nil, nil, 11);
		
				if name then
					frame:SetScript("OnUpdate",nil)
					MoonTimeDoorKeeper:RegisterLayout( self );
				end 
		
			end)
		end
	end)
				
	--[[			
				--MoonTimeDoorKeeper:RegisterLayout( self );
			print("variablen geladen")
			end
			if event=="INSPECT_READY" then
				print("talente sollten da sein")
				
				for a = 18, 18, 1 do
					local name, texture = GetTalentInfo(a, 1, nil, nil, 11)	
					print(name)			
				end
				MoonTimeDoorKeeper:RegisterLayout( self );
			end

	
		end
	)
	

	--]]
	
	frame.createLayout = function( self ) 
		LayoutFrame = Layout(self.Mainframe, self.Objectframe)
		LayoutFrame:createLayout()
	end

	frame.Hide = function()
		LayoutFrame:Hide()
	end
	frame.Show = function()
		LayoutFrame:Show()
	end
	frame.Update = function()
		LayoutFrame:Update()
	end

	frame.deleteLayout = function()
		LayoutFrame:deleteLayout()
	end
	

	
end																		-- Ende initialize

registerLayout(NameOfLayout)