-- MoonTimeConfig.lua

local version = 9;

local function noBrainBuildConfig(MoonTimeConfigPanel)

if ( GetLocale() == "deDE" ) then
	L = MoonTime_noBrainConfig_Strings["deDE"]
else
	L = MoonTime_noBrainConfig_Strings["enGB"]
end

-- Make a child panel
local MoonTime_Layout_noBrain_ConfigPanel = CreateFrame( "ScrollFrame", "MyAddonChild", MoonTimeConfigPanel);
MoonTime_Layout_noBrain_ConfigPanel:SetBackdropColor(1,0,1,1)
MoonTime_Layout_noBrain_ConfigPanel:SetWidth(200)
 MoonTime_Layout_noBrain_ConfigPanel:SetHeight(200)
  --MoonTime_Layout_noBrain_ConfigPanel:SetOrientation('VERTICAL')


MoonTime_Layout_noBrain_ConfigPanel.name = "noBrain";
 -- Specify childness of this panel (this puts it under the little red [+], instead of giving it a normal AddOn category)
 MoonTime_Layout_noBrain_ConfigPanel.parent = MoonTimeConfigPanel.name;
 
 local MoonTime_Layout_noBrain_ScrollPanel = CreateFrame( "Frame", "MyAddonScrollChild", MoonTimeConfigPanel);

 MoonTime_Layout_noBrain_ScrollPanel:SetHeight(500)
 MoonTime_Layout_noBrain_ScrollPanel:SetWidth(100)
 
 MoonTime_Layout_noBrain_ConfigPanel:SetScrollChild(MoonTime_Layout_noBrain_ScrollPanel)
 -- Add the child to the Interface Options
 InterfaceOptions_AddCategory(MoonTime_Layout_noBrain_ConfigPanel);
 
 
 
local textbox = MoonTime:CreateFontString(MoonTime_Layout_noBrain_ConfigPanel, "textbox", "ARTWORK", "GameFontNormalLarge", "TOPLEFT", MoonTime_Layout_noBrain_ConfigPanel, "TOPLEFT", 10, -10, 200, 20, "LEFT", "CENTER",  1, 1, 1, 1 );
	textbox:SetText("|cffFFFF00".."Layout noBrain".."|r")
	textbox:Show()	
local textbox = MoonTime:CreateFontString(MoonTime_Layout_noBrain_ConfigPanel, "textbox", "ARTWORK", "GameFontNormal", "TOPLEFT", textbox, "BOTTOMLEFT", 0, 0, 500, 100, "LEFT", "CENTER",  1, 1, 1, 1 );
	textbox:SetText(L["description"])
	textbox:SetHeight(textbox:GetStringHeight())
	textbox:Show()	
	

local editframe9 = MoonTime:CreateFrame("EditBox", "MoonTimeEditBox9", MoonTime_Layout_noBrain_ConfigPanel, "InputBoxTemplate","TOPLEFT", textbox, "BOTTOMLEFT", 10, -10, 50,12)
	editframe9:SetAutoFocus(false) 
	editframe9:SetText(MoonTime_DB["Layout_noBrain"]["blink_factor"]);
	editframe9:SetCursorPosition(0)
	editframe9:Show()
	
local textbox = MoonTime:CreateFontString(MoonTime_Layout_noBrain_ConfigPanel, "textbox", "ARTWORK", "GameFontNormal", "LEFT", editframe9, "RIGHT", 5, 0, 200, 30, "LEFT", "CENTER",  1, 1, 1, 1 );
	textbox:SetText(L["noBrainConfig_Factor"])
	textbox:SetJustifyH("LEFT")
	textbox:Show()	
 
		

local editframe8 = MoonTime:CreateFrame("EditBox", "MoonTimeEditBox8", MoonTime_Layout_noBrain_ConfigPanel, "InputBoxTemplate", "LEFT", editframe9, "RIGHT", 200, 0, 50, 12)
	editframe8:SetAutoFocus(false) 
	editframe8:SetText(MoonTime_DB["Layout_noBrain"]["blink_time_descale"]);
	editframe8:SetCursorPosition(0)
	editframe8:Show()


local textbox = MoonTime:CreateFontString(MoonTime_Layout_noBrain_ConfigPanel, "textbox", "ARTWORK", "GameFontNormal", "LEFT", editframe8, "RIGHT", 5, 0, 200, 30, "LEFT", "CENTER",  1, 1, 1, 1 );
	textbox:SetText(L["noBrainConfig_Time"])
	textbox:Show()		



		
		

local textbox = MoonTime:CreateFontString(MoonTime_Layout_noBrain_ConfigPanel, "textbox", "ARTWORK", "GameFontNormal", "TOPLEFT", editframe9, "BOTTOMLEFT", -10, -10, 500, 20, "LEFT", "CENTER",  1, 1, 1, 1 );
	textbox:SetText(L["noBrainConfig_ActiveSpells"])
	textbox:Show()

		
		
		local checkbutton_1 = MoonTime:CreateFrame("CheckButton", "CheckButton_1", MoonTime_Layout_noBrain_ConfigPanel, "UICheckButtonTemplate", "TOPLEFT", textbox, "BOTTOMLEFT", 4, 0, 28, 28)
			if MoonTime_DB["Layout_noBrain"]["blinkspells"][SS_icon] then checkbutton_1:SetChecked() end
			checkbutton_1:Show()
	
		local test = CreateFrame("Frame", "testbox",  MoonTime_Layout_noBrain_ConfigPanel);
	
	 	local textbox = MoonTime:CreateFontString(MoonTime_Layout_noBrain_ConfigPanel, "textbox2", "ARTWORK","GameFontNormal", "TOPLEFT", checkbutton_1, "TOPRIGHT", 10, -4, 200, 20, "LEFT", "CENTER",  1, 1, 1, 1 );
			textbox:SetText(SS_name)
			textbox:Show()	
	
		--Mondfeuer
		local checkbutton_2 = MoonTime:CreateFrame("CheckButton", "CheckButton_2", MoonTime_Layout_noBrain_ConfigPanel, "UICheckButtonTemplate", "TOPLEFT", textbox, "TOPRIGHT", 0, 0, 28, 28)
			if MoonTime_DB["Layout_noBrain"]["blinkspells"][MF_icon] then checkbutton_2:SetChecked() end
			checkbutton_2:Show()
			
	 	local textbox = MoonTime:CreateFontString(MoonTime_Layout_noBrain_ConfigPanel, "textbox2", "ARTWORK","GameFontNormal", "TOPLEFT", checkbutton_2, "TOPRIGHT", 10, -4, 200, 20, "LEFT", "CENTER",  1, 1, 1, 1 );
			textbox:SetText(MF_name)
			textbox:Show()	
			
		--Zorn
		local checkbutton_4 = MoonTime:CreateFrame("CheckButton", "CheckButton_1", MoonTime_Layout_noBrain_ConfigPanel, "UICheckButtonTemplate", "TOPLEFT", checkbutton_1, "BOTTOMLEFT", 0, 0, 28, 28)
			if MoonTime_DB["Layout_noBrain"]["blinkspells"][W_icon] then checkbutton_4:SetChecked() end
			checkbutton_4:Show()
			
	 	local textbox = MoonTime:CreateFontString(MoonTime_Layout_noBrain_ConfigPanel, "textbox", "ARTWORK","GameFontNormal", "TOPLEFT", checkbutton_4, "TOPRIGHT", 10, -4, 200, 20, "LEFT", "CENTER",  1, 1, 1, 1 );
			textbox:SetText(W_name)
			textbox:Show()

		--Sonnenfeuer
		local checkbutton_3 = MoonTime:CreateFrame("CheckButton", "CheckButton_3", MoonTime_Layout_noBrain_ConfigPanel, "UICheckButtonTemplate", "TOPLEFT", textbox, "TOPRIGHT", 0, 0, 28, 28)
			if MoonTime_DB["Layout_noBrain"]["blinkspells"][SunF_icon] then checkbutton_3:SetChecked() end
			checkbutton_3:Show()
			
	 	local textbox = MoonTime:CreateFontString(MoonTime_Layout_noBrain_ConfigPanel, "textbox", "ARTWORK","GameFontNormal", "TOPLEFT", checkbutton_3, "TOPRIGHT", 10, -4, 200, 20, "LEFT", "CENTER",  1, 1, 1, 1 );
			textbox:SetText(SunF_name)
			textbox:Show()

			
		--Sternenfeuer
		local checkbutton_5 = MoonTime:CreateFrame("CheckButton", "CheckButton_1", MoonTime_Layout_noBrain_ConfigPanel, "UICheckButtonTemplate", "TOPLEFT", checkbutton_4, "BOTTOMLEFT", 0, 0, 28, 28)
			if MoonTime_DB["Layout_noBrain"]["blinkspells"][SF_icon] then checkbutton_5:SetChecked() end
			checkbutton_5:Show()
			
	 	local textbox = MoonTime:CreateFontString(MoonTime_Layout_noBrain_ConfigPanel, "textbox", "ARTWORK","GameFontNormal", "TOPLEFT", checkbutton_5, "TOPRIGHT", 10, -4, 200, 20, "LEFT", "CENTER",  1, 1, 1, 1 );
			textbox:SetText(SF_name)
			textbox:Show()
			
		--Insektenschwarm
		local checkbutton_6 = MoonTime:CreateFrame("CheckButton", "CheckButton_1", MoonTime_Layout_noBrain_ConfigPanel, "UICheckButtonTemplate", "TOPLEFT", textbox, "TOPRIGHT", 0, 0, 28, 28)
			if MoonTime_DB["Layout_noBrain"]["blinkspells"][IS_icon] then checkbutton_6:SetChecked() end
			checkbutton_6:Show()
			
	 	local textbox = MoonTime:CreateFontString(MoonTime_Layout_noBrain_ConfigPanel, "textbox", "ARTWORK","GameFontNormal", "TOPLEFT", checkbutton_6, "TOPRIGHT", 10, -4, 200, 20, "LEFT", "CENTER",  1, 1, 1, 1 );
			textbox:SetText(IS_name)
			textbox:Show()


	local labelframe2 = MoonTime_Layout_noBrain_ConfigPanel:CreateFontString(nil,"ARTWORK","GameFontNormal")
	
		labelframe2:SetPoint("TOPLEFT", MoonTime_Layout_noBrain_ConfigPanel, "TOPLEFT", 10, -200)
		
		labelframe2:SetWidth(300)
		labelframe2:SetJustifyH("LEFT")
		labelframe2:SetJustifyV("TOP")
		labelframe2:SetTextColor( 1, 1, 1, 1 );
		labelframe2:SetText(L["noBrainConfig_Rotation"])


	 
		

		
	local editframe = CreateFrame("EditBox", "MoonTimeEditBox", MoonTime_Layout_noBrain_ConfigPanel, "InputBoxTemplate")
	 
	editframe:SetPoint("TOPLEFT", labelframe2, "BOTTOMLEFT", 0, -100)
	editframe:SetWidth(400)
	editframe:SetHeight(100)
	editframe:SetText("text")
	editframe:SetMultiLine()
	editframe:SetAutoFocus(false) 
	editframe:Hide()
	 
	editframe:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", 
		edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
		tile = true, tileSize = 16, edgeSize = 16, 
		insets = { left = 4, right = 4, top = 4, bottom = 4 }});

local aussen = CreateFrame("Frame","Aussenframe", MoonTime_Layout_noBrain_ConfigPanel)
	aussen:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/Tooltips/UI-Tooltip-Border",tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
	aussen:SetBackdropColor(0,0,0.2)
	aussen:SetPoint("TOPLEFT", labelframe2, "BOTTOMLEFT", 0, -20)
	aussen:SetSize(580,300)
	aussen:Show();

local MoonTime_Layout_noBrain_ScrollFrame = CreateFrame("ScrollFrame", "MoonTime_Layout_noBrain_ScrollFramereviewFrame", MoonTime_Layout_noBrain_ConfigPanel, "UIPanelScrollFrameTemplate")
	MoonTime_Layout_noBrain_ScrollFrame:SetPoint("TOPLEFT", aussen, "TOPLEFT", 10, -10)
	MoonTime_Layout_noBrain_ScrollFrame.name = "Scrollframe";
 
local MoonTime_Layout_noBrain_ScrollFrameScrollChild = CreateFrame("Frame", "MoonTime_Layout_noBrain_ScrollFramereviewSC", MoonTime_Layout_noBrain_ScrollFrame)
 
 
local PADDING = 5
local height = 280
local width = 538
 

 
local labelframe = CreateFrame("EditBox", "TestEditBox", MoonTime_Layout_noBrain_ScrollFrame)
 
 labelframe:SetFont("Fonts\\ARIALN.TTF",14,"none")
 labelframe:SetPoint("TOPLEFT", MoonTime_Layout_noBrain_ScrollFrame, "TOPLEFT", 0, 0)
	
 labelframe:SetWidth(width)
	
 labelframe:SetJustifyH("LEFT")
 labelframe:SetJustifyV("TOP")
 labelframe:SetTextColor( 1, 1, 1, 1 );
 labelframe:SetMultiLine()
 labelframe:SetText(MoonTime_DB["Layout_noBrain"]["boxtext"])
 labelframe:SetAutoFocus(false)
 labelframe.h = 0;
 labelframe:SetScript("OnTextChanged",
	function (self)
	
		local x,y = labelframe:GetSize()

		if labelframe.h ~= MoonTime_Layout_noBrain_ScrollFrame:GetVerticalScrollRange() then
			MoonTime_Layout_noBrain_ScrollFrame:SetVerticalScroll(MoonTime_Layout_noBrain_ScrollFrame:GetVerticalScroll() + MoonTime_Layout_noBrain_ScrollFrame:GetVerticalScrollRange()-labelframe.h) 
			
			if MoonTime_Layout_noBrain_ScrollFrame:GetVerticalScroll()<0 then
				MoonTime_Layout_noBrain_ScrollFrame:SetVerticalScroll(0);
			end
			
			if labelframe.h == 0 then
				MoonTime_Layout_noBrain_ScrollFrame:SetVerticalScroll(MoonTime_DB["Layout_noBrain"]["boxtextposi"]);
			end

			labelframe.h = MoonTime_Layout_noBrain_ScrollFrame:GetVerticalScrollRange();
		end

	end
)


-- Set the size of the scroll child
MoonTime_Layout_noBrain_ScrollFrameScrollChild:SetSize(width, height)
 
-- Size and place the parent frame, and set the scrollchild to be the
-- frame of font strings we've created
MoonTime_Layout_noBrain_ScrollFrame:SetSize(width, height)
MoonTime_Layout_noBrain_ScrollFrame:SetScrollChild(labelframe)


MoonTime_Layout_noBrain_ScrollFrameScrollChild:SetSize(width, height)

		MoonTime_Layout_noBrain_ConfigPanel:SetScript("OnShow",
			function(self)
				labelframe:SetText(MoonTime_DB["Layout_noBrain"]["boxtext"]);
			end
		)
		
MoonTime_Layout_noBrain_ConfigPanel.okay = function()
	if ( MoonTime_Layout_noBrain_ConfigPanel:IsShown() ) then
		MoonTime_DB["Layout_noBrain"]["blink_factor"]  = editframe9:GetText();
		MoonTime_DB["Layout_noBrain"]["blink_time_descale"] = editframe8:GetText();
		MoonTime_DB["Layout_noBrain"]["blinkspells"][SS_icon] = checkbutton_1:GetChecked();
		MoonTime_DB["Layout_noBrain"]["blinkspells"][MF_icon] = checkbutton_2:GetChecked();
		MoonTime_DB["Layout_noBrain"]["blinkspells"][SunF_icon] = checkbutton_3:GetChecked();
		MoonTime_DB["Layout_noBrain"]["blinkspells"][W_icon] = checkbutton_4:GetChecked();
		MoonTime_DB["Layout_noBrain"]["blinkspells"][SF_icon] = checkbutton_5:GetChecked();
		MoonTime_DB["Layout_noBrain"]["blinkspells"][IS_icon] = checkbutton_6:GetChecked();

		MoonTime_DB["Layout_noBrain"]["boxtext"]  = labelframe:GetText();
		MoonTime_DB["Layout_noBrain"]["boxtextposi"] = MoonTime_Layout_noBrain_ScrollFrame:GetVerticalScroll();
	
		MoonTime:setLayout(MoonTime_DB["layout"])
	end	
end
	
MoonTime_Layout_noBrain_ConfigPanel:Hide()
return MoonTime_Layout_noBrain_ConfigPanel

end


-- ****************************************
--
-- DO NOT CHANGE ANYTHING BELOW THIS 
--
-- ****************************************

local function registerConfig( )									-- Beginn initialize
	local configFrame
	local frame = CreateFrame( "Frame", "frame", UIPARENT	)
	frame:RegisterEvent("VARIABLES_LOADED");
	frame:SetScript("OnEvent", 
		function( self, event )
			if event=="VARIABLES_LOADED" then							-- falls das ausloesende Event VARIABLES_LOADED ist ...
																		-- werden die ausstehenden Events registriert
				if ( not MoonTime_DB["Layout_noBrain"] or MoonTime_DB["Layout_noBrain"]["version"] < version ) then
					frame:UpdateDB()
				end
				
				MoonTimeDoorKeeper:RegisterConfig( self );
			end
		end
	)
	
	frame.createConfig = function( MainConfigFrame )
		configFrame = noBrainBuildConfig( MainConfigFrame )
	end
	
	frame.UpdateDB = function()
		MoonTime_DB["Layout_noBrain"] = {
			["version"] = version,
			["boxtext"] = "function mynext(frame)\n\n\nlocal spell, _, _, _, startTime, endTime, _, castID, _ = UnitCastingInfo(\"player\");\nlocal EDir, EPower = frame:GetEclipseDirection();\n\n\nlocal gcdstart, gcd = GetSpellCooldown(8921);\nlocal casttime = max(gcdstart+gcd-GetTime(),0);\n\nif spell == SF_name and EDir == \"sun\" then\n   EPower = EPower+40\nend\n\nif spell == W_name and EDir == \"moon\"  then\n  EPower = EPower-30\nend\n\nif spell == SS_name then\n  if EDir == \"moon\" then\n    EPower = EPower-40\n  else\n    EPower = EPower+40\n  end\nend\n\nif (EDir == \"sun\" and EPower >= 100) or frame:isSolar() then\n  if frame:GetMoonfireCD() < 0 then\n    return MF_icon\n  end\n  if frame:GetSunfireCD() < 0 then\n    return SunF_icon\n  end\nend\n\nif (EDir == \"moon\" and EPower <= -100) or frame:isLunar() then\n  if frame:GetSunfireCD() < 0 then\n    return SunF_icon\n  end\n  if frame:GetMoonfireCD() < 0 then\n    return MF_icon\n  end\nend\n\nif frame:GetStarsurgeCD() < 1.5 and spell ~=SS_name then\n  return SS_icon\nend\n\nif EDir == \"moon\" and spell==W_name and EPower <=-100 then\n  return SF_icon\nend\n\nif EDir == \"sun\" and spell==SF_name and EPower >=100 then\n  return W_icon\nend\n\nif EDir == \"moon\" then\n    return W_icon\nend\n\nreturn SF_icon\n\n\n\nend",
			["boxtextposi"] = 0,
			["blink_factor"] = 8,
			["blink_time_descale"] = 0.15,
			["blinkspells"] = {
				[SS_icon] = true,
				[MF_icon] = true,
				[SunF_icon] = true,
				[W_icon] = false,
				[SF_icon] = false,
				[IS_icon] = true,
			},
		}
	end
end																		-- Ende initialize

registerConfig(NameOfLayout)
